import React, { Component } from 'react';
import { View, Text, TextInput, TouchableOpacity, Platform } from 'react-native';
import { colors } from '../assets/styles/colors-theme';
import Icon from 'react-native-vector-icons/FontAwesome';
import { width, height } from '../services/screen';
Icon.loadFont();
import { inject, observer } from "mobx-react"
import { observable, makeObservable } from 'mobx'
const SettingButton = inject("appStore")(observer(class SettingButton extends React.Component {

    constructor(props) {
        super(props);
        this.store = props.appStore;
    }
    render() {
        return (
            <TouchableOpacity
                onPress={() => this.props.onPress && this.props.onPress()}
                style={{
                    height: 50,
                    borderRadius: 15,
                    width: 100,
                    justifyContent: 'center',
                    alignItems: 'center',
                    flexDirection: 'row',

                }}>
                <Text style={{ fontSize: 20, color: colors.buttonColor }}>
                    {this.store.text.setting}
                </Text>
                <Icon name='cog' color={colors.buttonColor} size={30} />
            </TouchableOpacity>
        );
    }
}))
export default SettingButton;
